; Copyright (C) 2018-2019 Francis (Fritz) Mahnke.

; This file is part of c64-3d-graphics-series.

; c64-3d-graphics-series is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; c64-3d-graphics-series is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with c64-3d-graphics-series.  If not, see
; <https://www.gnu.org/licenses/>.

!macro vic_bank_1 {
    lda $dd00
    and #$fc
    ora #$02
    sta $dd00
}

!macro vic_bitmap_enable {
    lda $d011
    ora #$20
    sta $d011
}

!macro vic_bitmap_hi {
    lda $d018
    ora #$08
    sta $d018
}

; Bank 0 fill
!macro disp_fill .symbol {
    lda #$00
    tax
    lda #.symbol
clrloop
    sta $0400,x
    sta $0500,x
    sta $0600,x
    sta $0700,x
    dex
    bne clrloop
}

; Bank 1 fill
!macro disp_fill_1 .symbol {
    lda #$00
    tax
    lda #.symbol
-   sta $4400,x
    sta $4500,x
    sta $4600,x
    sta $4700,x
    dex
    bne -
}

!macro bitmap_fill .symbol {
    lda #$00
    tax
    lda #.symbol
-   sta $2000,x
    sta $2100,x
    sta $2200,x
    sta $2300,x
    sta $2400,x
    sta $2500,x
    sta $2600,x
    sta $2700,x
    sta $2800,x
    sta $2900,x
    sta $2a00,x
    sta $2b00,x
    sta $2c00,x
    sta $2d00,x
    sta $2e00,x
    sta $2f00,x
    sta $3000,x
    sta $3100,x
    sta $3200,x
    sta $3300,x
    sta $3400,x
    sta $3500,x
    sta $3600,x
    sta $3700,x
    sta $3800,x
    sta $3900,x
    sta $3a00,x
    sta $3b00,x
    sta $3c00,x
    sta $3d00,x
    sta $3e00,x
    sta $3f00,x
    dex
    bne -
}

!macro bitmap_fill_0_2 .symbol {
    lda #$00
    tax
    lda #.symbol
-   sta $2000,x
    sta $2100,x
    sta $2200,x
    sta $2300,x
    sta $2400,x
    sta $2500,x
    sta $2600,x
    sta $2700,x
    sta $2800,x
    sta $2900,x
    sta $2a00,x
    sta $2b00,x
    sta $2c00,x
    sta $2d00,x
    sta $2e00,x
    sta $2f00,x
    sta $3000,x
    sta $3100,x
    sta $3200,x
    sta $3300,x
    sta $3400,x
    sta $3500,x
    sta $3600,x
    sta $3700,x
    sta $3800,x
    sta $3900,x
    sta $3a00,x
    sta $3b00,x
    sta $3c00,x
    sta $3d00,x
    sta $3e00,x
    sta $3f00,x
    dex
    bne -
}

!macro bitmap_fill_1_2 .symbol {
    lda #$00
    tax
    lda #.symbol
-   sta $6000,x
    sta $6100,x
    sta $6200,x
    sta $6300,x
    sta $6400,x
    sta $6500,x
    sta $6600,x
    sta $6700,x
    sta $6800,x
    sta $6900,x
    sta $6a00,x
    sta $6b00,x
    sta $6c00,x
    sta $6d00,x
    sta $6e00,x
    sta $6f00,x
    sta $7000,x
    sta $7100,x
    sta $7200,x
    sta $7300,x
    sta $7400,x
    sta $7500,x
    sta $7600,x
    sta $7700,x
    sta $7800,x
    sta $7900,x
    sta $7a00,x
    sta $7b00,x
    sta $7c00,x
    sta $7d00,x
    sta $7e00,x
    sta $7f00,x
    dex
    bne -
}

